#include <cstdio>
#include <cstdlib>

class Circle {
    float rad;
    int x,y;
public:
    // default constructor
    //   Circle c;
    //   Circle c = Circle();
    //   Circle* c = new Circle();
    // 
    Circle(){
        rad = 0;
        x = y = 0;
        printf("Circle()\n");
    }

    // destructor
    // gets called when object goes out of scope.
    // gets called when delete is called.
    //
    ~Circle(){
        rad = 0;
        x = y = 0;
        printf("~Circle()\n");
    }

};


int main(){
    
    {
        printf("declare: Circle c;\n");
        Circle c;
    }
    
    {
        printf("declare: Circle c = Circle();\n");
        Circle c = Circle();
    }

    {
        printf("declare: Circle* c;\n");    
        Circle* c;
    }


    {
        printf("declare: Circle* c = new Circle();\n");    
        Circle* c = new Circle();

        printf("calling delete c;\n");    
        delete c;

        printf("at end of scope...\n");
    }

    return 0;
}



